package com.a486software.PrintUSB;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.*;


import android.app.Activity;
import android.content.Intent;

import android.os.Bundle;
import android.net.Uri;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.*;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.Toast;
import android.view.View;
import android.R;
import android.app.AlertDialog;

import java.util.HashMap;
import java.util.Map;
import java.lang.ref.WeakReference;
import java.util.Set;
import java.io.UnsupportedEncodingException;


import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;

import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;

import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.app.PendingIntent;

import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbManager;

import com.felhr.usbserial.*;
import com.felhr.usbserial.UsbSerialDevice;
import com.felhr.usbserial.UsbSerialInterface;



@Version(1.2f)
@Permissions(values={"android.permission.INTERNET","android.hardware.usb.host","android.hardware.usb.action.USB_DEVICE_ATTACHED"})
@ShortName("PrintUSB")
@DependsOn(values={"usbserial"})
@ActivityObject

//@ActivityObject

public class PrintUSB  extends Activity {

    public final String ACTION_USB_PERMISSION = "com.a486software.PrintUSB.PrintUSB.USB_PERMISSION";
   
    UsbManager usbManager;
    UsbDevice device;
    UsbSerialDevice serialPort;
    UsbDeviceConnection connection;
    int comm_open;

	@Override
    protected void onCreate(Bundle savedInstanceState) {

        BA.Log("onCreate INI");
        super.onCreate(savedInstanceState);
      

       
        //
        // Comm
        //
        comm_open = 0;
        usbManager = (UsbManager) getSystemService(this.USB_SERVICE);
        IntentFilter filter = new IntentFilter();
        filter.addAction(ACTION_USB_PERMISSION);
        filter.addAction(UsbManager.ACTION_USB_DEVICE_ATTACHED);
        filter.addAction(UsbManager.ACTION_USB_DEVICE_DETACHED);
        registerReceiver(broadcastReceiver, filter);



        BA.Log("onCreate FIM");


       
       

        // Start comm
        StartComm();



    }


@Override
    public void onResume()
    {
        BA.Log("onResume INI");
        super.onResume();
       
         // Imprime
        String string = "Ola Susana\n";
        serialPort.write(string.getBytes());
        System.out.println("Data Sent : " + string + "\n");
        

        BA.Log("onResume FIM");
    }

@Override
    public void onPause()
    {
        BA.Log("onPause INI");
        
        StopComm();

        BA.Log("onPause FIM");
    }

 //
    // Handle device answer
    //
    UsbSerialInterface.UsbReadCallback mCallback = new UsbSerialInterface.UsbReadCallback() {
        //Defining a Callback which triggers whenever data is read.
        @Override
        public void onReceivedData(byte[] arg0) {
            BA.Log("UsbReadCallback");
            String data = null;
            try {
                data = new String(arg0, "UTF-8");
                data.concat("/n");
                BA.Log("Answer from device:" + data);
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }


        }
    };
    //
    // Handle broadcast
    //
    private final BroadcastReceiver broadcastReceiver = new BroadcastReceiver() {
        //Broadcast Receiver to automatically start and stop the Serial connection.
        @Override
        public void onReceive(Context context, Intent intent) {
            BA.Log("SERIAL onReceive");
            if (intent.getAction().equals(ACTION_USB_PERMISSION)) {
                boolean granted = intent.getExtras().getBoolean(UsbManager.EXTRA_PERMISSION_GRANTED);
                if (granted) {
                    BA.Log("SERIAL granted");
                    connection = usbManager.openDevice(device);
                    serialPort = UsbSerialDevice.createUsbSerialDevice(device, connection);
                    if (serialPort != null) {
                        if (serialPort.open()) { //Set Serial Connection Parameters.
                            //setUiEnabled(true);
                            serialPort.setBaudRate(9600);
                            serialPort.setDataBits(UsbSerialInterface.DATA_BITS_8);
                            serialPort.setStopBits(UsbSerialInterface.STOP_BITS_1);
                            serialPort.setParity(UsbSerialInterface.PARITY_NONE);
                            serialPort.setFlowControl(UsbSerialInterface.FLOW_CONTROL_OFF);
                            serialPort.read(mCallback);
                            comm_open = 1;
                            BA.Log("SERIAL Serial Connection Opened!");

                        } else {
                            BA.Log("SERIAL PORT NOT OPEN");
                        }
                    } else {
                        BA.Log("SERIAL PORT IS NULL");
                    }
                } else {
                    BA.Log("SERIAL PERM NOT GRANTED");
                }
            } else if (intent.getAction().equals(UsbManager.ACTION_USB_DEVICE_ATTACHED)) {
                StartComm();
            } else if (intent.getAction().equals(UsbManager.ACTION_USB_DEVICE_DETACHED)) {
                StopComm();

            }
        }

        ;
    };
    //
    // Start comm
    //
    private void StartComm() {
        BA.Log("SERIAL START COMM");
        HashMap<String, UsbDevice> usbDevices = usbManager.getDeviceList();
        if (!usbDevices.isEmpty()) {
            boolean keep = true;
            for (Map.Entry<String, UsbDevice> entry : usbDevices.entrySet()) {
                device = entry.getValue();
                int deviceVID = device.getVendorId();
                BA.Log("SERIAL deviceVID:" + deviceVID);
                PendingIntent pi = PendingIntent.getBroadcast(this, 0, new Intent(ACTION_USB_PERMISSION), 0);
                usbManager.requestPermission(device, pi);
                // Uses first USB device - for me is fine ;)
                break;
            }
        }
    }
    //
    // CLoses serial comm
    //
    private void StopComm() {
        BA.Log("SERIAL STOP COMM");
        if(comm_open ==1) {
            serialPort.close();
        }
        comm_open = 0;
    }


}